#include "StdAfx.h"
#include "MESdb.h"

CMESdb::CMESdb(void)
{
}

CMESdb::~CMESdb()
{
	if (m_pConnection != NULL) m_pConnection->Close(), m_pConnection.Release(), m_pConnection = NULL;

	::CoUninitialize();
}

TString CMESdb::ToString(_variant_t var)
{
	CString strValue;
	switch (var.vt)
	{
	case VT_BSTR: //ַ
	case VT_LPSTR:
	case VT_LPWSTR:
		strValue = (LPCTSTR)(_bstr_t)var;
		break;
	case VT_I1:   //޷ַ
	case VT_UI1:
		strValue.Format(_T("%d"), var.bVal);
		break;
	case VT_I2:   //
		strValue.Format(_T("%d"), var.iVal);
		break;
	case VT_UI2:   //޷Ŷ
		strValue.Format(_T("%u"), var.uiVal);
		break;
	case VT_INT: //
		strValue.Format(_T("%d"), var.intVal);
		break;
	case VT_I4:   //
	case VT_I8:   //
		strValue.Format(_T("%d"), var.lVal);
		break;
	case VT_UINT:   //޷
		strValue.Format(_T("%d"), var.uintVal);
		break;
	case VT_UI4:    //޷
	case VT_UI8:    //޷ų
		strValue.Format(_T("%d"), var.ulVal);
		break;
	case VT_VOID:
		strValue.Format(_T("%08x"), var.byref);
		break;
	case VT_R4:   //
		strValue.Format(_T("%f"), var.fltVal);
		break;
	case VT_R8:   //˫
		strValue.Format(_T("%f"), var.dblVal);
		break;
	case VT_DECIMAL: //С
		strValue.Format(_T("%f"), (double)var);
		break;
	case VT_CY:
		{
			COleCurrency cy = var.cyVal;
			strValue = cy.Format();
		}
		break;
	case VT_BLOB:
	case VT_BLOB_OBJECT:
	case 0x2011:
		strValue = _T("[BLOB]");
		break;
	case VT_BOOL:   //  
		strValue = var.boolVal ? _T("TRUE") : _T("FALSE");
		break;
	case VT_DATE: //
		{
			DATE dt = var.date;
			COleDateTime da = COleDateTime(dt);
			strValue = da.Format(_T("%Y-%m-%d %H:%M:%S"));
		}
		break;
	case VT_NULL://NULLֵ
	case VT_EMPTY:   //
		strValue = _T("");
		break;
	case VT_UNKNOWN:   //δ֪
	default:
		strValue = _T("VT_UNKNOW");
		break;
	}

	return TString(strValue);
}

bool CMESdb::InitAdo()
{
	if (m_pConnection == NULL)
	{
		try
		{
			TCHAR szConnectString[MAX_PATH] = {0};
			_stprintf_s(szConnectString,
					_T("Provider=sqloledb;Data Source=%s;Initial Catalog=%s;User Id=%s;Password=%s; "),
					_T("10.126.64.131"),			// IPַ;
					_T("MESOtherData"),
					_T("XMUpdate"),
					_T("695Xm@123#"));

			m_pConnection.CreateInstance(__uuidof(Connection));
			m_pConnection->PutConnectionTimeout(60);
			HRESULT hr = m_pConnection->Open(_bstr_t(szConnectString), "", "", adModeUnknown);

			return SUCCEEDED(hr);
		}
		catch (_com_error &e)
		{
			_bstr_t bstrSource(e.Source());
			_bstr_t bstrDescription(e.Description());
		}
	}

	return false;
}

bool CMESdb::InitAdo2()
{
	if (m_pConnection2 == NULL)
	{
		try
		{
			TCHAR szConnectString[MAX_PATH] = {0};
			_stprintf_s(szConnectString,
				_T("Provider=sqloledb;Data Source=%s;Initial Catalog=%s;User Id=%s;Password=%s; "),
				_T("10.126.64.131"),
				_T("MESBaseDB"),
				_T("XMUpdate"),
				_T("695Xm@123#"));

			m_pConnection2.CreateInstance(__uuidof(Connection));
			m_pConnection2->PutConnectionTimeout(60);
			HRESULT hr = m_pConnection2->Open(_bstr_t(szConnectString), "", "", adModeUnknown);

			return SUCCEEDED(hr);
		}
		catch (_com_error &e)
		{
			_bstr_t bstrSource(e.Source());
			_bstr_t bstrDescription(e.Description());
		}
	}

	return false;
}

bool CMESdb::InitAdo3()
{
	if (m_pConnection3 == NULL)
	{
		try
		{
			TCHAR szConnectString[MAX_PATH] = {0};
			_stprintf_s(szConnectString,
				_T("Provider=sqloledb;Data Source=%s;Initial Catalog=%s;User Id=%s;Password=%s; "),
				_T("10.126.64.131"),
				_T("MESOtherData"),
				_T("it_oper"),
				_T("IT@SMES2018"));

			m_pConnection3.CreateInstance(__uuidof(Connection));
			m_pConnection3->PutConnectionTimeout(60);
			HRESULT hr = m_pConnection3->Open(_bstr_t(szConnectString), "", "", adModeUnknown);

			return SUCCEEDED(hr);
		}
		catch (_com_error &e)
		{
			_bstr_t bstrSource(e.Source());
			_bstr_t bstrDescription(e.Description());
		}
	}

	return false;
}

bool CMESdb::Query(TString strSQL, std::map<TString, TString> &data)
{
	try
	{
		CString strSql;
		_RecordsetPtr rsData;
		// ʵ;
		rsData.CreateInstance(__uuidof(Recordset));
		// ʵ;
		HRESULT hr = rsData->Open(_variant_t(strSQL.c_str()), _variant_t((IDispatch*)m_pCurrConnection, true), adOpenDynamic, adLockReadOnly, adCmdText);

		if (SUCCEEDED(hr))
		{
			Field *   field = NULL;	
			Fields *  fields = NULL;
			long      ColCount = 0;
			BSTR      bstrColName;

			hr = rsData->get_Fields(&fields);	//õ¼ֶμ
			if(SUCCEEDED(hr))
				fields->get_Count(&ColCount);

			while (rsData->EndOfFile == VARIANT_FALSE)
			{
#if 0
				DWORD dwCount = rsData->GetFields()->Count;
				for ( DWORD i = 0; i < dwCount; i++ )
				{
					FieldPtr fp = rsData->GetFields();
					fields = rsData->Fields;
					TString strName = (LPCTSTR)rsData->Fields->Item[i]->GetName();

					TString strName1 = (LPCTSTR)rsData->GetFields()->GetItem(i)->GetName();

					_variant_t var = rsData->GetCollect(strName.c_str());

					data.insert(std::make_pair<TString,TString>(strName, ToString(var)));
				}
#else
				for(long i=0; i<ColCount; i++)			
				{			
					fields->Item[i]->get_Name(&bstrColName);	//õ¼//еֶ
					_variant_t var = rsData->GetCollect(bstrColName);
					data.insert(std::make_pair<TString,TString>(bstrColName, ToString(var)));
				}
#endif
				rsData->MoveNext();
			}

			if(SUCCEEDED(hr))
				fields->Release();//ͷָ

			rsData->Close();
			return true;
		}
	}
	catch (_com_error &e)
	{
		_bstr_t bstrSource(e.Source());
		_bstr_t bstrDescription(e.Description());
		//WriteTextLog(_T("%s,%d =>%08lx,%s,%s,%s"), __FUNCTIONW__, __LINE__, e.Error(), e.ErrorMessage(), (TCHAR*)bstrSource, (TCHAR*)bstrDescription);
	}

	return false;
}

bool CMESdb::GetProcessCode(TString &data, TString strProcessName/* =_T */)
{
	try
	{
		CString strSql;
		_RecordsetPtr rsData;
		rsData.CreateInstance(__uuidof(Recordset));
		strSql.Format(_T("select Process_Code from Process_List where Process_Name='%s'"), strProcessName.c_str());
		HRESULT hr = rsData->Open(_variant_t(strSql), _variant_t((IDispatch*)m_pConnection, true), adOpenDynamic, adLockPessimistic, adCmdText);

		if (SUCCEEDED(hr))
		{
			if (rsData->EndOfFile == VARIANT_FALSE)
			{
				data = rsData->GetCollect(_T("Process_Code")).bstrVal;
			}

			rsData->Close();
		}

		return true;
	}
	catch (_com_error &e)
	{
		_bstr_t bstrSource(e.Source());
		_bstr_t bstrDescription(e.Description());
		//WriteTextLog(_T("%s,%d =>%08lx,%s,%s,%s"), __FUNCTIONW__, __LINE__, e.Error(), e.ErrorMessage(), (TCHAR*)bstrSource, (TCHAR*)bstrDescription);
	}

	return false;
}

bool CMESdb::GetCompanyCode(TString &data, TString strCompanyName)
{
	try
	{
		CString strSql;
		_RecordsetPtr rsData;
		rsData.CreateInstance(__uuidof(Recordset));
		strSql.Format(_T("select CompanyCode from T_Company where CompanyName='%s'"), strCompanyName.c_str());
		HRESULT hr = rsData->Open(_variant_t(strSql), _variant_t((IDispatch*)m_pConnection2, true), adOpenDynamic, adLockPessimistic, adCmdText);

		if (SUCCEEDED(hr))
		{
			if (rsData->EndOfFile == VARIANT_FALSE)
			{
				data = rsData->GetCollect(_T("CompanyCode")).bstrVal;
			}

			rsData->Close();
		}

		return true;
	}
	catch (_com_error &e)
	{
		_bstr_t bstrSource(e.Source());
		_bstr_t bstrDescription(e.Description());
		//WriteTextLog(_T("%s,%d =>%08lx,%s,%s,%s"), __FUNCTIONW__, __LINE__, e.Error(), e.ErrorMessage(), (TCHAR*)bstrSource, (TCHAR*)bstrDescription);
	}

	return false;
}


bool CMESdb::IsExitTVSN(TString TVSN)
{
	try
	{
		CString strSql;
		_RecordsetPtr rsData;
		rsData.CreateInstance(__uuidof(Recordset));
		strSql.Format(_T("select count(1) as val from tvinfo where tvsn='%s'"), TVSN.c_str());
		HRESULT hr = rsData->Open(_variant_t(strSql), _variant_t((IDispatch*)m_pConnection3, true), adOpenDynamic, adLockPessimistic, adCmdText);

		_variant_t data;
		if (SUCCEEDED(hr))
		{			
			if (rsData->EndOfFile == VARIANT_FALSE)
			{
				data = rsData->GetCollect(_T("val"));
			}

			rsData->Close();
		}

		return data.lVal > 0 ? true : false;
	}
	catch (_com_error &e)
	{
		_bstr_t bstrSource(e.Source());
		_bstr_t bstrDescription(e.Description());
		//WriteTextLog(_T("%s,%d =>%08lx,%s,%s,%s"), __FUNCTIONW__, __LINE__, e.Error(), e.ErrorMessage(), (TCHAR*)bstrSource, (TCHAR*)bstrDescription);
	}

	return false;
}

bool CMESdb::GetNextProcessCode(TString TVSN, TString &data)
{
	try
	{
		CString strSql;
		_RecordsetPtr rsData;
		rsData.CreateInstance(__uuidof(Recordset));
		strSql.Format(_T("select dbo.GetNextProcessCode('%s')"), TVSN.c_str());
		HRESULT hr = rsData->Open(_variant_t(strSql), _variant_t((IDispatch*)m_pConnection3, true), adOpenDynamic, adLockPessimistic, adCmdText);

		if (SUCCEEDED(hr))
		{			
			if (rsData->EndOfFile == VARIANT_FALSE)
			{
				data = rsData->GetCollect(_T("")).bstrVal;
			}

			rsData->Close();
		}

		return data.size() > 0 ? true : false;
	}
	catch (_com_error &e)
	{
		_bstr_t bstrSource(e.Source());
		_bstr_t bstrDescription(e.Description());
		//WriteTextLog(_T("%s,%d =>%08lx,%s,%s,%s"), __FUNCTIONW__, __LINE__, e.Error(), e.ErrorMessage(), (TCHAR*)bstrSource, (TCHAR*)bstrDescription);
	}

	return false;
}

bool CMESdb::Scan(TString TVSN, TString LineCode, TString PcProcessCode, TString Host, TString IP, TString User, TString UserName, TString PartStrs, TString &ErroMsg)
{
	try
	{
		_CommandPtr cmd;
		cmd.CreateInstance(__uuidof(Command));
		cmd->CommandType = adCmdStoredProc;			// Ϊ洢; 
		cmd->ActiveConnection = m_pConnection3;		// ;
		cmd->CommandText = _T("ProcessScan2");		// 洢;
		// Ӳ;
		cmd->Parameters->Append(cmd->CreateParameter(_T("p_tvsn"), adVarChar, adParamInput, 50, _variant_t(TVSN.c_str())));
		cmd->Parameters->Append(cmd->CreateParameter(_T("p_line"), adVarChar, adParamInput, 10, _variant_t(LineCode.c_str())));
		cmd->Parameters->Append(cmd->CreateParameter(_T("p_pcprocesscode"), adVarChar, adParamInput, 10, _variant_t(PcProcessCode.c_str())));
		cmd->Parameters->Append(cmd->CreateParameter(_T("p_host"), adVarChar, adParamInput, 20, _variant_t(Host.c_str())));
		cmd->Parameters->Append(cmd->CreateParameter(_T("p_ip"), adVarChar, adParamInput, 20, _variant_t(IP.c_str())));
		cmd->Parameters->Append(cmd->CreateParameter(_T("p_user"), adVarChar, adParamInput, 20, _variant_t(User.c_str())));
		cmd->Parameters->Append(cmd->CreateParameter(_T("p_username"), adVarChar, adParamInput, 20, _variant_t(UserName.c_str())));
		cmd->Parameters->Append(cmd->CreateParameter(_T("p_partstrs"), adVarChar, adParamInput, 500, _variant_t(PartStrs.c_str())));
		cmd->Parameters->Append(cmd->CreateParameter(_T("p_result"), adVarChar, adParamOutput, 10));
		cmd->Parameters->Append(cmd->CreateParameter(_T("p_erro"), adVarChar, adParamOutput, 500));

		cmd->Execute(NULL, NULL, NULL);
		TString strResult = cmd->Parameters->GetItem(_T("p_result"))->GetValue().bstrVal;
		ErroMsg = cmd->Parameters->GetItem(_T("p_erro"))->GetValue().bstrVal;
		cmd.Detach();
		//cmd->Release();

		if ( _tcsicmp(strResult.c_str(), _T("false")) != 0 )
			return true;
	}
	catch (_com_error &e)
	{
		_bstr_t bstrSource(e.Source());
		_bstr_t bstrDescription(e.Description());
		//WriteTextLog(_T("%s,%d =>%08lx,%s,%s,%s"), __FUNCTIONW__, __LINE__, e.Error(), e.ErrorMessage(), (TCHAR*)bstrSource, (TCHAR*)bstrDescription);
	}

	return false;
}

bool CMESdb::UploadTestData(TString strSN, TString strResult, TString strDateTime)
{
	try
	{
		CString strSql;
		//strSql.Format(_T("insert into aaaa(SN,Result,UpdateTime) values ('%s','%s','%s')"), strSN.c_str(), strResult.c_str(), strDateTime.c_str());
		strSql.Format(_T("insert into aaaa(SN,Result,UpdateTime) values ('%s','%s',GETDATE())"), strSN.c_str(), strResult.c_str());

		m_pConnection3->CursorLocation = adUseClient;
		m_pConnection3->Execute(_bstr_t(strSql), NULL, adExecuteNoRecords);

		return true;
	}
	catch (_com_error &e)
	{
		_bstr_t bstrSource(e.Source());
		_bstr_t bstrDescription(e.Description());
		//WriteTextLog(_T("%s,%d =>%08lx,%s,%s,%s"), __FUNCTIONW__, __LINE__, e.Error(), e.ErrorMessage(), (TCHAR*)bstrSource, (TCHAR*)bstrDescription);
	}

	return false;
}

bool CMESdb::GetWhiteid(TString strBom, TString &Whiteid)
{
	try
	{
		CString strSql;
		_RecordsetPtr rsData;
		rsData.CreateInstance(__uuidof(Recordset));
		strSql.Format(_T("select whiteid,remark from CPCWHITE where bom ='%s'"), strBom.c_str());
		HRESULT hr = rsData->Open(_variant_t(strSql), _variant_t((IDispatch*)m_pConnection3, true), adOpenDynamic, adLockPessimistic, adCmdText);

		if (SUCCEEDED(hr))
		{			
			if (rsData->EndOfFile == VARIANT_FALSE)
			{
				Whiteid = rsData->GetCollect(_T("whiteid")).bstrVal;
			}

			rsData->Close();
		}

		return Whiteid.size() > 0 ? true : false;
	}
	catch (_com_error &e)
	{
		_bstr_t bstrSource(e.Source());
		_bstr_t bstrDescription(e.Description());
		//WriteTextLog(_T("%s,%d =>%08lx,%s,%s,%s"), __FUNCTIONW__, __LINE__, e.Error(), e.ErrorMessage(), (TCHAR*)bstrSource, (TCHAR*)bstrDescription);
	}

	return false;
}

bool CMESdb::GetWhiteValue(TString strWhiteid, TString strWhiteName,TString &strValue)
{
	try
	{
		CString strSql;
		_RecordsetPtr rsData;
		rsData.CreateInstance(__uuidof(Recordset));
		strSql.Format(_T("select propvalue from CPCWHITELINE where whiteid ='%s' and propname='%s'"), strWhiteid.c_str(), strWhiteName.c_str());
		HRESULT hr = rsData->Open(_variant_t(strSql), _variant_t((IDispatch*)m_pConnection3, true), adOpenDynamic, adLockPessimistic, adCmdText);

		if (SUCCEEDED(hr))
		{			
			if (rsData->EndOfFile == VARIANT_FALSE)
			{
				strValue = rsData->GetCollect(_T("propvalue")).bstrVal;
			}

			rsData->Close();
		}

		return strValue.size() > 0 ? true : false;
	}
	catch (_com_error &e)
	{
		_bstr_t bstrSource(e.Source());
		_bstr_t bstrDescription(e.Description());
		//WriteTextLog(_T("%s,%d =>%08lx,%s,%s,%s"), __FUNCTIONW__, __LINE__, e.Error(), e.ErrorMessage(), (TCHAR*)bstrSource, (TCHAR*)bstrDescription);
	}

	return false;
}

bool CMESdb::GetDeltaEInfo(TString strBatch, TString &strDeltaEType, TString &strDeltaValue)
{
	// 1ͨBOMѯwhiteid
	TString strWhiteid;
	if ( GetWhiteid(strBatch, strWhiteid) )
	{
		// 2ͨwhiteidѯƽ
		if ( GetWhiteValue(strWhiteid, _T("DeltaE_Test_Standard"), strDeltaEType) && GetWhiteValue(strWhiteid, _T("DeltaE_Test_Target"), strDeltaValue) )
			return true;
	}
	
	return false;
}